var greenRe = /fill: green;/;
var blueRe = /fill: blue;/;
var noneRe = /fill: none;/;
var reClass = /\((.+)\)/;
var gRects = { };

function getClassFromTxt(aTxt)
{
  return reClass.exec(aTxt)[1] * 1;
}

function colorit(n, regexp, newcolor)
{
  var tab = gRects[n];
  for (var i = 0; i < tab.length; ++i)
  {
    var elt = tab[i];
    var style = elt.getAttribute("style");
    style = style.replace(regexp, newcolor);
    elt.setAttribute("style", style);
  }
}

function greenit(n)
{
  colorit(n, blueRe, "fill: green;");
}

function blueit(n)
{
  colorit(n, greenRe, "fill: blue;");
}

function preprocessElt(e)
{
  var pts = e.getAttribute("points");
  pts = pts.split(" ");
  if (pts.length != 5 || pts[0] != pts[4])
    return;
  for (var i = 0; i < 4; ++i)
    pts[i] = pts[i].split(",");
  var x, y, height, width;
  if (pts[0][0] == pts[3][0] && pts[1][0] == pts[2][0] &&
      pts[0][1] == pts[1][1] && pts[2][1] == pts[3][1])
  {
    x = Math.min(pts[0][0], pts[1][0]);
    width = Math.max(pts[0][0], pts[1][0]) - x;
    y = Math.min(pts[0][1], pts[2][1]);
    height = Math.max(pts[0][1], pts[2][1]) - y;
  } else {
    if (pts[0][0] == pts[1][0] && pts[2][0] == pts[3][0] &&
        pts[0][1] == pts[3][1] && pts[1][1] == pts[2][1])
    {
      x = Math.min(pts[0][0], pts[2][0]);
      width = Math.max(pts[0][0], pts[2][0]) - x;
      y = Math.min(pts[0][1], pts[2][1]);
      height = Math.max(pts[0][1], pts[2][1]) - y;
    } else {
      return;
    }
  }
  if (x == -2)
  {
    // dot likes to put a useless rectangle to make the background of the image
    e.parentNode.removeChild(e);
    return;
  }
  var rect = e.ownerDocument.createElementNS(SVG, "rect");
  var style = e.getAttribute("style");
  style = style.replace(noneRe, "fill:white;");
  rect.setAttribute("style", style);
  rect.setAttribute("x", x);
  rect.setAttribute("y", y);
  rect.setAttribute("height", height);
  rect.setAttribute("width", width);
  var txtElt = e.parentNode.getElementsByTagName("text")[0];
  var txt = txtElt.textContent;

  if (greenRe.test(style))
  {
    var n = getClassFromTxt(txt);
    if (!gRects[n])
      gRects[n] = [rect];
    else
      gRects[n].push(rect);
    rect.addEventListener("mouseover", function () { blueit(n) }, false);
    rect.addEventListener("mouseout", function () { greenit(n) }, false);
  }
  rect.addEventListener("mouseover", function() { setStatus(txt); }, false);
  rect.addEventListener("mouseout", function() { setStatus(''); }, false);
  txtElt.parentNode.removeChild(txtElt);
  e.parentNode.replaceChild(rect, e);
}

function doPreprocessingInternal(aList, aLength, aCur)
{
  setStatus("Preprocessing: " + Math.round((aLength - aCur) / aLength * 100) + "%");
  var i = 0;
  while (aCur >= 0 && i < 20)
  {
    preprocessElt(aList[aCur]);
    --aCur;
    ++i;
  }
  if (aCur >= 0)
    setTimeout(doPreprocessingInternal, 1, aList, aLength, aCur);
  else
    setStatus("Preprocessing done.");
}

function doPreprocessing(aDoc)
{
  var polygons = aDoc.getElementsByTagName("polygon");
  var l = polygons.length;
  doPreprocessingInternal(polygons, l, l - 1);
}
