#!/bin/sh
# 
# This file is part of Transformers.
# Copyright (C) 2007  EPITA Research and Development Laboratory.
#
# Transformers is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
# USA.


. $SRCDIR/defs

produce=${0%%.run}
$MAKE $AM_MAKEFLAGS $produce

case $produce in
  *.sdf) parse_cmd="sglri --lex --layout --appl --inj -p ${top_builddir}/sdf-detgen/src/syn/DetBoxedSdf.tbl";;
  *.str) parse_cmd="parse-stratego";;
  *) echo "Error: Don't know how to parse the file $produce" >&2
     exit 1;;
esac

$SRCDIR/diff-parse.sh "$parse_cmd" $produce $SRCDIR/$produce.ref;

if test $? -ne 0; then
  echo "Error: $produce and $produce.ref are different." >&2
  exit 1
fi
