/* native-lazy.h: prototypes and structures for str-lazy.
* This file is part of Transformers.
* Copyright (C) 2005, 2006  EPITA Research and Development Laboratory.
*
* Transformers is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
* USA.
*/
#ifndef _NATIVE_LAZY_H
# define _NATIVE_LAZY_H
# include <srts/stratego.h>

ATerm LAZY_getv(ATerm t);
ATerm LAZY_getr(ATerm t);
ATerm LAZY_new_value(void);
ATerm LAZY_formula(StrCL s,
		   ATerm result, ATerm input);

typedef struct _formula_list_t {
  struct _formula_node_t *cur;
  struct _formula_list_t *next;
} formula_list_t;

typedef struct _value_list_t {
  struct _value_node_t *cur;
  struct _value_list_t *next;
} value_list_t;

typedef ATerm (*strategy_t)(StrSL, ATerm);

typedef struct _formula_node_t {
  strategy_t strategy;
  ATerm input;
} formula_node_t;

typedef struct _value_node_t {
  struct _formula_list_t *formulas;
  ATerm value;
} value_node_t;

typedef struct _value_blob {
  int magic;
  value_node_t *node;
} value_blob_t;

#endif /* !_NATIVE_LAZY_H */
